/*******************************************************************************
 * Copyright (c) 2012 IBM Corporation and others.
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * and Eclipse Distribution License v. 1.0 which accompanies this distribution.
 *
 * The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 * and the Eclipse Distribution License is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 *
 * Contributors:
 *
 *     Russell Boykin       - initial API and implementation
 *     Alberto Giammaria    - initial API and implementation
 *     Chris Peters         - initial API and implementation
 *     Gianluca Bernardini  - initial API and implementation
 *	   Sam Padgett	       - initial API and implementation
 *     Michael Fiedler     - adapted for OSLC4J
 *     Jad El-khoury        - initial implementation of code generator (https://bugs.eclipse.org/bugs/show_bug.cgi?id=422448)
 *
 * This file is generated by org.eclipse.lyo.oslc4j.codegenerator
 *******************************************************************************/

package se.kth.md.assume.adaptors.gitlab.resources;

import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.text.SimpleDateFormat;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;
import java.util.Iterator;
import javax.servlet.http.HttpServletRequest;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import javax.ws.rs.core.UriBuilder;

import org.eclipse.lyo.oslc4j.core.annotation.OslcAllowedValue;
import org.eclipse.lyo.oslc4j.core.annotation.OslcDescription;
import org.eclipse.lyo.oslc4j.core.annotation.OslcMemberProperty;
import org.eclipse.lyo.oslc4j.core.annotation.OslcName;
import org.eclipse.lyo.oslc4j.core.annotation.OslcNamespace;
import org.eclipse.lyo.oslc4j.core.annotation.OslcOccurs;
import org.eclipse.lyo.oslc4j.core.annotation.OslcPropertyDefinition;
import org.eclipse.lyo.oslc4j.core.annotation.OslcRange;
import org.eclipse.lyo.oslc4j.core.annotation.OslcReadOnly;
import org.eclipse.lyo.oslc4j.core.annotation.OslcRepresentation;
import org.eclipse.lyo.oslc4j.core.annotation.OslcResourceShape;
import org.eclipse.lyo.oslc4j.core.annotation.OslcTitle;
import org.eclipse.lyo.oslc4j.core.annotation.OslcValueType;
import org.eclipse.lyo.oslc4j.core.model.AbstractResource;
import org.eclipse.lyo.oslc4j.core.model.Link;
import org.eclipse.lyo.oslc4j.core.model.Occurs;
import org.eclipse.lyo.oslc4j.core.model.OslcConstants;
import org.eclipse.lyo.oslc4j.core.model.Representation;
import org.eclipse.lyo.oslc4j.core.model.ValueType;

import se.kth.md.assume.adaptors.gitlab.servlet.ServletListener;
import se.kth.md.assume.adaptors.gitlab.GitLabConstants;
import se.kth.md.assume.adaptors.gitlab.resources.IFolderResource;
import se.kth.md.assume.adaptors.gitlab.resources.IPerson;

// Start of user code imports
// End of user code

@OslcNamespace(GitLabConstants.FILE_MANAGEMENT_NAMSPACE)
@OslcName(GitLabConstants.FILERESOURCE)
@OslcResourceShape(title = "FileResource Resource Shape", describes = GitLabConstants.TYPE_FILERESOURCE)
public interface IFileResource
{


    @OslcName("created")
    @OslcPropertyDefinition(GitLabConstants.DUBLIN_CORE_NAMSPACE + "created")
    @OslcOccurs(Occurs.ZeroOrOne)
    @OslcValueType(ValueType.DateTime)
    @OslcReadOnly(false)
    @OslcTitle("")
    public Date getCreated();

    @OslcName("title")
    @OslcPropertyDefinition(GitLabConstants.DUBLIN_CORE_NAMSPACE + "title")
    @OslcOccurs(Occurs.ExactlyOne)
    @OslcValueType(ValueType.XMLLiteral)
    @OslcReadOnly(false)
    public String getTitle();

    @OslcName("modfied")
    @OslcPropertyDefinition(GitLabConstants.DUBLIN_CORE_NAMSPACE + "modfied")
    @OslcOccurs(Occurs.ZeroOrOne)
    @OslcValueType(ValueType.DateTime)
    @OslcReadOnly(false)
    @OslcTitle("")
    public Date getModfied();

    @OslcName("fileSize")
    @OslcPropertyDefinition(GitLabConstants.FILE_MANAGEMENT_NAMSPACE + "fileSize")
    @OslcOccurs(Occurs.ExactlyOne)
    @OslcValueType(ValueType.Integer)
    @OslcReadOnly(false)
    public Integer getFileSize();

    @OslcName("creator")
    @OslcPropertyDefinition(GitLabConstants.DUBLIN_CORE_NAMSPACE + "creator")
    @OslcOccurs(Occurs.ExactlyOne)
    @OslcValueType(ValueType.Resource)
    @OslcRange({GitLabConstants.TYPE_PERSON})
    @OslcReadOnly(false)
    public Link getCreator();

    @OslcName("previewURL")
    @OslcPropertyDefinition(GitLabConstants.FILE_MANAGEMENT_NAMSPACE + "previewURL")
    @OslcOccurs(Occurs.ZeroOrOne)
    @OslcReadOnly(false)
    public URI getPreviewURL();

    @OslcName("containerFolder")
    @OslcPropertyDefinition(GitLabConstants.FILE_MANAGEMENT_NAMSPACE + "containerFolder")
    @OslcOccurs(Occurs.ZeroOrOne)
    @OslcValueType(ValueType.Resource)
    @OslcRange({GitLabConstants.TYPE_FOLDERRESOURCE})
    @OslcReadOnly(false)
    public Link getContainerFolder();

    @OslcName("downloadURL")
    @OslcPropertyDefinition(GitLabConstants.FILE_MANAGEMENT_NAMSPACE + "downloadURL")
    @OslcDescription("")
    @OslcOccurs(Occurs.ZeroOrOne)
    @OslcReadOnly(false)
    public URI getDownloadURL();


    public void setCreated(final Date created );
    public void setTitle(final String title );
    public void setModfied(final Date modfied );
    public void setFileSize(final Integer fileSize );
    public void setCreator(final Link creator );
    public void setPreviewURL(final URI previewURL );
    public void setContainerFolder(final Link containerFolder );
    public void setDownloadURL(final URI downloadURL );
}

